
grammar test1
{
terminals
   a b c

nonterminals
   S

start S

type int

principles
   .S: .a | .b | .c;


{%
	public:
		void parse(int i)
		{
			run(i);
		}
%}

}

source
{%
#include <iostream>

using namespace std;

void test1::getToken(Symbol<int> &s) const
{
	char c;
	cin >> c;

	s.attr  = 0;

	if (c == 'a' || c == 'A')
		s.id = test1::a;
	else if (c == 'b' || c == 'B')
		s.id = test1::b;
	else if (c == 'c' || c == 'C')
		s.id = test1::c;
	else
		s.id = 0;

}

main()
{
   try
   {
      test1 parser;

      parser.parse(0);
   }
   catch(exception& e)
   {
      cerr << "Exception: " << e.what() << endl;
   }
   catch(...)
   {
      cerr << "unexpected exception" << endl;
   }
}

%}
