//
//
//

grammar test4
{
terminals
   a b c

nonterminals
   S B SyntaxError

error SyntaxError
start S
type int

principles

	.S : .a S >> .B !
	    ;

	a.S : 	.a S >> .B
	    |   . !
	    ;

	.B : .b	>> .c;

	.SyntaxError : . {% std::cout << "Syntax error" << std::endl; %}
      ;

{%
	public:
		test4() {}
		void parse(int i)
		{
			//trace();
			//traceAll();
			run(i);
		}
%}
}

source
{%
#include <iostream>

using namespace std;

void test4::getToken(Symbol<int> &s) const
{
	char c;
	cin >> c;

	s.attr  = 0;

	if (c == 'a' || c == 'A')
		s.id = test4::a;
	else if (c == 'b' || c == 'B')
		s.id = test4::b;
	else if (c == 'c' || c == 'C')
		s.id = test4::c;
	else
		s.id = 0;

}

main()
{
   test4 parser;

   parser.parse(0);
}

%}
